%  data for nlmpcdm2
% Copyright 1994-2001 The MathWorks, Inc. 
% $Revision: 1.10 $

% Matrices of the linearized paper machine model

A=[-1.93 0 0 0; .394 -.426 0 0; 0 0 -.63 0; .82 -.784 .413 -.426];
B=[1.274 1.274 0;0 0 0;1.34 -.65 .203;0 0 0];
C=[0 1 0 0; 0 0 1 0; 0 0 0 1];
D=zeros(3,3);

% Discretize the linear model and save in MOD form.

dt=2;
[PHI,GAM]=c2dmp(A,B,dt);
minfo=[dt,4,2,1,0,3,0];
imod=ss2mod(PHI,GAM,C,D,minfo);

% Store the model in Mod Step format

[model,dmodel] = mod2step(imod,20);
m = 3;
p = 10;
ywt=[0.2,0,1];     % unequal weighting of y1 and y3, no control of y2
uwt=0.6*[1 1];      % Equal weighting of u1 and u2.
u_lim=[-10*[1 1] 10*[1 1] 2*[1 1]];      % Constraints on u
y_lim=[-inf -inf -inf inf inf inf];      % No constraints on y
usat = u_lim;
tfilter = [];
y0 = [0 0 0];
u0 = [0 0];
d0 = 0;
nd = 1;
r = [0 0 0];
Kmpc = mpccon(model,ywt,uwt,m,p);

%msgbox(['Ready!  Use  Simulink''s SIMULATION menu to START demo.', ...
%  '  When run ends, double click on PLOT RESULTS'])
