%
%  s-function for the demo plant -- a CSTR
%
%  The system dynamics can be described as follows:
%     		dT/dt =  - 1.2 T + Ti + 0.2 Tst
%   		dh/dt =  - 1/1.5 h + fi
%     with the initial condition
%		T(0)  = 58.33333    (u(1))
%		h(0)  = 1.5         (u(2))
%		Tst(0)= 100
%		fi(0) = 1
%		Ti(0) = 50

% Copyright 1994-2001 The MathWorks, Inc. 
% $Revision: 1.8 $

function [sys,x0] = tempvol(t,x,u,flag)
ti=50;
if abs(flag) == 1
	if t == 0
	   u(1) = 100;
	   u(2) = 1;
	end
	f1 = -1.2*x(1) + ti + 0.2*u(1);
	f2 = u(2) - 1/1.5*x(2);
	sys=[f1;f2];
elseif flag == 0
	sys = [2 0 2 2 0 0]; x0=[58.3;1.5];
elseif flag == 3
     	sys = [x(1);x(2)];
else
	sys = [];
end

