/*
 * This file is not available for use in any application other than as a
 * MATLAB(R) MEX file for use with the Simulink(R) Accelerator product.
 */

/*
 * Real-Time Workshop code generation for Simulink model "pl1mod1_acc.mdl".
 *
 * Model Version                        : 1.16
 * Real-Time Workshop file version      : 5.0 $Date: 2002/05/30 19:21:33 $
 * Real-Time Workshop file generated on : Wed Mar 19 15:23:05 2003
 * TLC version                          : 5.0 (Jun 18 2002)
 * C source code generated on           : Wed Mar 19 15:23:06 2003
 */

#include <math.h>
#include <string.h>
#include "pl1mod1_acc.h"
#include "pl1mod1_acc_private.h"
#include <stdio.h>
#include "simstruc.h"

#define CodeFormat                      S-Function
#define AccDefine1                      Accelerator_S-Function

/* Outputs for root system: '<Root>' */
static void mdlOutputs(SimStruct *S, int_T tid)
{
  /* simstruct variables */
  pl1mod1_BlockIO *pl1mod1_B = (pl1mod1_BlockIO *) _ssGetBlockIO(S);
  pl1mod1_ContinuousStates *pl1mod1_X = (pl1mod1_ContinuousStates*)
    ssGetContStates(S);
  pl1mod1_D_Work *pl1mod1_DWork = (pl1mod1_D_Work *) ssGetRootDWork(S);
  pl1mod1_Parameters *pl1mod1_P = (pl1mod1_Parameters *) ssGetDefaultParam(S);

  if (ssIsContinuousTask(S, tid)) {     /* Sample time: [0.0, 0.0] */

    /* TransferFcn Block: <S1>/Transfer Fcn */
    pl1mod1_B->Transfer_Fcn =
      pl1mod1_P->Transfer_Fcn_C*pl1mod1_X->Transfer_Fcn_CSTATE;
  }

  if (ssIsSampleHit(S, 1, tid)) {       /* Sample time: [0.1, 0.0] */

    /* Scope: '<Root>/Scope y' */
    /* Call into Simulink for Scope */
    ssCallAccelRunBlock(S, 0, 1, SS_CALL_MDL_OUTPUTS);
  }

  if (ssIsContinuousTask(S, tid)) {     /* Sample time: [0.0, 0.0] */

    /* Step: '<Root>/Step' */
    if (ssIsMajorTimeStep(S)) {
      if (ssGetTaskTime(S,tid) >= pl1mod1_P->Step_Time) {
        pl1mod1_DWork->Step_MODE = 1;
      } else {
        pl1mod1_DWork->Step_MODE = 0;
      }
    }
    /* Output value */
   pl1mod1_B->Step = (pl1mod1_DWork->Step_MODE == 1) ? pl1mod1_P->Step_YFinal :
      pl1mod1_P->Step_Y0;
  }

  if (ssIsSampleHit(S, 1, tid)) {       /* Sample time: [0.1, 0.0] */

    /* ZeroOrderHold: '<S1>/Zero-Order Hold' */
    pl1mod1_B->Zero_Order_Hold = pl1mod1_B->Step;
  }
}

/* Update for root system: '<Root>' */
#define MDL_UPDATE
static void mdlUpdate(SimStruct *S, int_T tid)
{
}

/* Derivatives for root system: '<Root>' */
#define MDL_DERIVATIVES
static void mdlDerivatives(SimStruct *S)
{
  /* simstruct variables */
  pl1mod1_BlockIO *pl1mod1_B = (pl1mod1_BlockIO *) _ssGetBlockIO(S);
  pl1mod1_ContinuousStates *pl1mod1_X = (pl1mod1_ContinuousStates*)
    ssGetContStates(S);
  pl1mod1_StateDerivatives *pl1mod1_Xdot = (pl1mod1_StateDerivatives*)
    ssGetdX(S);
  pl1mod1_Parameters *pl1mod1_P = (pl1mod1_Parameters *) ssGetDefaultParam(S);

  /* TransferFcn Block: <S1>/Transfer Fcn */
  {

    pl1mod1_Xdot->Transfer_Fcn_CSTATE =
      pl1mod1_P->Transfer_Fcn_B*pl1mod1_B->Zero_Order_Hold;
    pl1mod1_Xdot->Transfer_Fcn_CSTATE +=
      (pl1mod1_P->Transfer_Fcn_A)*pl1mod1_X->Transfer_Fcn_CSTATE;
  }
}

/* ZeroCrossings for root system: '<Root>' */
#define MDL_ZERO_CROSSINGS
static void mdlZeroCrossings(SimStruct *S)
{
  /* simstruct variables */
  pl1mod1_Parameters *pl1mod1_P = (pl1mod1_Parameters *) ssGetDefaultParam(S);
  pl1mod1_NonsampledZCs *pl1mod1_NonsampledZC = (pl1mod1_NonsampledZCs *)
    ssGetNonsampledZCs(S);

  /* Step Block: <Root>/Step */
  pl1mod1_NonsampledZC->Step_NSZC = ssGetT(S) - pl1mod1_P->Step_Time;
}

/* Function to initialize sizes */
static void mdlInitializeSizes(SimStruct *S)
{

  /* checksum */
  ssSetChecksumVal(S, 0, 1874919233U);
  ssSetChecksumVal(S, 1, 2560641194U);
  ssSetChecksumVal(S, 2, 387680473U);
  ssSetChecksumVal(S, 3, 3598794038U);

  /* options */
  ssSetOptions(S, SS_OPTION_EXCEPTION_FREE_CODE);

  /* Accelerator check memory map size match for DWork */
  if (ssGetSizeofDWork(S) != sizeof(pl1mod1_D_Work)) {
    ssSetErrorStatus(S,"Unexpected error: Internal DWork sizes do "
     "not match for accelerator mex file.");
  }

  /* Accelerator check memory map size match for BlockIO */
  if (ssGetSizeofGlobalBlockIO(S) != sizeof(pl1mod1_BlockIO)) {
    ssSetErrorStatus(S,"Unexpected error: Internal BlockIO sizes do "
     "not match for accelerator mex file.");
  }

  /* model parameters */
  _ssSetDefaultParam(S, (real_T *) &pl1mod1_DefaultParameters);
}

/* Empty mdlInitializeSampleTimes function (never called) */
static void mdlInitializeSampleTimes(SimStruct *S) { }

/* Empty mdlTerminate function (never called) */
static void mdlTerminate(SimStruct *S) { }

/* MATLAB MEX Glue */
#include "simulink.c"

